print "----------------------------------------------------------"
print "     >>>> ClipTheApex F1 Tyre Strategy Analyser <<<<"
print "----------------------------------------------------------"
print "  Made June 2011 by sushifiesta based on work by jez101"
print "----------------------------------------------------------"
print ""
print "USER VARIABLES"
print "---------------"
print " * Type one number on each line then hit enter"
print " * All times are measured in seconds"
print " * Degradation rates are in seconds/lap"
print " * Pit stop time is the additional lap time to make a stop"
print " * Example values: 70, 0.5, 0.1, 0.05, 11.2"
print ""
laps = input("* Race Laps: ")#70
diff = input("* Lap Time Difference between Option/Prime: ")#0.5
optdeg = input("* Option Degradation Rate: ")#0.1
prideg = input("* Prime Degradation Rate: ")#0.05
pit = input("* Pit stop time: ")#11.2
print ""
print "----------------------------------------------------------"
print ""
print "* O stands for option tyre and P stands for prime tyre."
print "* The no. after O/P is the optimum no. of laps in each stint."
print "* Time is the time added due to tyre wear and pit stops."
print ""
print "----------------------------------------------------------"
print ""
#------------------------

from numpy import array,append

opttimes = array([]) # store total time fors stints of all possible lengths on options
pritimes = array([]) # on primes
for i in range(1,laps+1):
    opttimes = append(opttimes,(optdeg*(i-1)*i)/2.0)
    pritimes = append(pritimes,((prideg*(i-1)*i)/2.0)+(diff*i))

#------------------------
    
# Possibilities:
# 1 stop:
#   Option, Prime
# 2 stop:
#   Option, Option, Prime
#   Option, Prime, Prime
# 3 stop:
#   Option, Option, Option, Prime
#   Option, Option, Prime, Prime
#   Option, Prime, Prime, Prime
# 4 stop:
#   Option, Option, Option, Prime, Prime
#   Option, Option, Prime, Prime, Prime
# 5 stop:
#   Option, Option, Option, Prime, Prime, Prime

#------------------------
    
print "Analysing 1 stop strategies..."
print ""
# aopt = 1st stint laps on options, bpri = 2nd stint laps on primes
tmin = 1000000
for a in range(1,laps):
    b = laps-a
    t = opttimes[a-1]+pritimes[b-1]
    if t<tmin:
        tmin=t
        aop = a
        bop = b

# add on pit stops to get total time
Top = tmin + pit

print "1) O:",aop,", P:",bop,", TIME:",Top,"secs"
print ""

#------------------------

print "Analysing 2 stop strategies..."
print ""

#opt,opt,pri
#opt,pri,pri
toopmin = 1000000
toppmin = 1000000
for a in range(1,laps-1):
    for b in range(1,laps-a):
        c = laps-a-b
        toop = opttimes[a-1]+opttimes[b-1]+pritimes[c-1]
        topp = opttimes[a-1]+pritimes[b-1]+pritimes[c-1]
        if toop<toopmin:
            toopmin=toop
            aoop = a
            boop = b
            coop = c
        if topp<toppmin:
            toppmin=topp
            aopp = a
            bopp = b
            copp = c
Toop = toopmin + 2*pit
Topp = toppmin + 2*pit
print "1) O:",aoop,", O:",boop,", P:",coop,", TIME:",Toop,"secs"
print "2) O:",aopp,", P:",bopp,", P:",copp,", TIME:",Topp,"secs"
print ""

#------------------------

print "Analysing 3 stop strategies..."
print ""

#Option, Option, Option, Prime
#Option, Option, Prime, Prime
#Option, Prime, Prime, Prime
tooopmin=1000000
tooppmin=1000000
topppmin=1000000
for a in range(1,laps-2):
    for b in range(1,laps-a):
        for c in range(1,laps-a-b):
            d = laps-a-b-c
            if d<0:
                print "help!"
            tooop = opttimes[a-1]+opttimes[b-1]+opttimes[c-1]+pritimes[d-1]
            toopp = opttimes[a-1]+opttimes[b-1]+pritimes[c-1]+pritimes[d-1]
            toppp = opttimes[a-1]+pritimes[b-1]+pritimes[c-1]+pritimes[d-1]
            if tooop<tooopmin:
                tooopmin = tooop
                aooop = a
                booop = b
                cooop = c
                dooop = d
            if toopp<tooppmin:
                tooppmin = toopp
                aoopp = a
                boopp = b
                coopp = c
                doopp = d
            if toppp<topppmin:
                topppmin = toppp
                aoppp = a
                boppp = b
                coppp = c
                doppp = d
Tooop = tooopmin + 3*pit
Toopp = tooppmin + 3*pit
Toppp = topppmin + 3*pit

print "1) O:",aooop,", O:",booop,", O:",cooop,", P:",dooop,", TIME:",Tooop,"secs"
print "2) O:",aoopp,", O:",boopp,", P:",coopp,", P:",doopp,", TIME:",Toopp,"secs"
print "3) O:",aoppp,", P:",boppp,", P:",coppp,", P:",doppp,", TIME:",Toppp,"secs"
print ""

#------------------------

print "Analysing 4 stop strategies..."
print ""

# Option, Option, Option, Prime, Prime
# Option, Option, Prime, Prime, Prime
toooppmin=1000000
toopppmin=1000000
for a in range(1,laps-3):
    for b in range(1,laps-a):
        for c in range(1,laps-a-b):
            for d in range(1,laps-a-b-c):
                e = laps-a-b-c-d
                tooopp = opttimes[a-1]+opttimes[b-1]+opttimes[c-1]+pritimes[d-1]+pritimes[e-1]
                tooppp = opttimes[a-1]+opttimes[b-1]+pritimes[c-1]+pritimes[d-1]+pritimes[e-1]
                if tooopp<toooppmin:
                    toooppmin = tooopp
                    aooopp = a
                    booopp = b
                    cooopp = c
                    dooopp = d
                    eooopp = e
                if tooppp<toopppmin:
                    toopppmin = tooppp
                    aooppp = a
                    booppp = b
                    cooppp = c
                    dooppp = d
                    eooppp = e
Tooopp = toooppmin + 4*pit
Tooppp = toopppmin + 4*pit

print "1) O:",aooopp,", O:",booopp,", O:",cooopp,", P:",dooopp,", P:",eooopp,", TIME:",Tooopp,"secs"
print "2) O:",aooppp,", O:",booppp,", P:",cooppp,", P:",dooppp,", P:",eooppp,", TIME:",Tooppp,"secs"
print ""

#------------------------

print "Analysing 5 stop strategies..."
print ""

# Option, Option, Option, Prime, Prime, Prime
tooopppmin=1000000
for a in range(1,laps-4):
    for b in range(1,laps-a):
        for c in range(1,laps-a-b):
            for d in range(1,laps-a-b-c):
                for e in range(1,laps-a-b-c-d):
                    f = laps-a-b-c-d-e
                    if f<0:
                        print "help!"
                    toooppp = opttimes[a-1]+opttimes[b-1]+opttimes[c-1]+pritimes[d-1]+pritimes[e-1]+pritimes[f-1]
                    if toooppp<tooopppmin:
                        tooopppmin = toooppp
                        aoooppp = a
                        boooppp = b
                        coooppp = c
                        doooppp = d
                        eoooppp = e
                        foooppp = f
Toooppp = tooopppmin + 5*pit

print "1) O:",aoooppp,", O:",boooppp,", O:",coooppp,", P:",doooppp,", P:",eoooppp,", P:",foooppp,", TIME:",Toooppp,"secs"
print ""
print "----------------------------------------------------------"
print ""

#------------------------

strats = ["op","oop","opp","ooop","oopp","oppp","ooopp","ooppp","oooppp"]
Tvals = [Top,Toop,Topp,Tooop,Toopp,Toppp,Tooopp,Tooppp,Toooppp]
minT = 1000000
index = 0
i = 0
while i<len(Tvals):
    if Tvals[i]<minT:
        minT = Tvals[i]
        index = i
    i+=1

beststrat = strats[index]

print "BEST STRATEGY:"
print "---------------"
print ""

if index==0:
    print " * 1 stop"
    print " * O:",aop,", P:",bop
    print " * Time:",Top,"secs"

if index==1:
    print " * 2 stops"
    print " * O:",aoop,", O:",boop,", P:",coop
    print " * Time:",Toop,"secs"

if index==2:
    print " * 2 stops"
    print " * O:",aopp,", P:",bopp,"P:",copp
    print " * Time:",Topp,"secs"

if index==3:
    print " * 3 stops"
    print " * O:",aooop,", O:",booop,", O:",cooop,", P:",dooop
    print " * Time:",Tooop,"secs"

if index==4:
    print " * 3 stops"
    print " * O:",aoopp,", O:",boopp,", P:",coopp,", P:",doopp
    print " * Time:",Toopp,"secs"

if index==5:
    print " * 3 stops"
    print " * O:",aoppp,", P:",boppp,", P:",coppp,", P:",doppp
    print " * Time:",Toppp,"secs"

if index==6:
    print " * 4 stops"
    print " * O:",aooopp,", O:",booopp,", O:",cooopp,", P:",dooopp,", P:",eooopp
    print " * Time:",Tooopp,"secs"

if index==7:
    print " * 4 stops"
    print " * O:",aooppp,", O:",booppp,", P:",cooppp,", P:",dooppp,", P:",eooppp
    print " * Time:",Tooppp,"secs"

if index==8:
    print " * 5 stops"
    print " * O:",aoooppp,", O:",boooppp,", O:",coooppp,", P:",doooppp,", P:",eoooppp,", P:",foooppp
    print " * Time:",Toooppp,"secs"

print ""
print "----------------------------------------------------------"
print ""
raw_input("Press ENTER to exit...")


